<?php 

namespace App\Helper;

class TableView {

    /**
     * sort
     */
    public static function add_sorter($column, $label, $route, $sort_by, $sort_order)
    {
        $request_data = request()->all();
        unset($request_data['sort_by']);
        unset($request_data['sort_order']);
        $locale = app()->getLocale();

        $route_param = ['locale' => $locale, 'sort_by' => $column, 'sort_order' => $sort_by === $column && $sort_order === 'asc' ? 'desc' : 'asc'];
        $route_param = array_merge($route_param, $request_data);
        $route = route($route, $route_param);

        $label = __($label);

        $sort_icon = "";
        if ($sort_by === $column)
        {
            $sort_icon = '<i class="fa fa-sort-' . ($sort_order === "asc" ? "up" : "down") . '"></i>';
        }
        
        $result = '<a href="' . $route . '"> ' . $label . ' ' . $sort_icon . '</a>';

        return $result;
    }
}

?>