<?php 

namespace App\Helper;

class Times {

    /**
     * minute_to_time
     */
    public static function minute_to_time($minutes)
    {
        $hours = floor($minutes / 60);
        $remainingMinutes = $minutes % 60;
        $formattedTime = sprintf("%02d:%02d:00", $hours, $remainingMinutes);
        return $formattedTime;
    }

    /**
     * second_to_time
     */
    public static function second_to_time($seconds)
    {
        $minute = floor($seconds / 60);
        return Times::minute_to_time($minute);
    }

    /**
     * sec_to_time
     */
    public static function sec_to_time($seconds)
    {
        return gmdate("H:i", $seconds);
    }

    /**
     * sec_to_time_full
     */
    public static function sec_to_time_full($seconds)
    {
        return gmdate("H:i:s", $seconds);
    }

    /**
     * time_to_second
     */
    public static function time_to_second($time) 
    {
        $list_time = explode(':', $time, 3);
        if (count($list_time) == 1) 
        {
            $list_time[] = 0;
            $list_time[] = 0;
        }
        else if (count($list_time) == 2) 
        {
            $list_time[] = 0;
        }
        list($hours, $minutes, $seconds) = $list_time;
        return ($hours * 3600) + ($minutes * 60) + $seconds;
    }

    /**
     * time_to_minute
     */
    public static function time_to_minute($time) 
    {
        $list_time = explode(':', $time, 3);
        if (count($list_time) == 1) 
        {
            $list_time[] = 0;
            $list_time[] = 0;
        }
        else if (count($list_time) == 2) 
        {
            $list_time[] = 0;
        }
        list($hours, $minutes, $seconds) = $list_time;
        return ($hours * 60) + $minutes;
    }
}

?>