<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\GroupsCompany;
use Illuminate\Http\Request;


class GroupController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $groups = GroupsCompany::all();
        return view('admin.companies.group', compact('groups'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create($locale)
    {
        //
        return view('group.index');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store($locale,Request $request)
    {
        $request->validate([
            'name' => 'required|string|max:255',
        ]);
    
        $group = new GroupsCompany();
        $group->name = $request->input('name');
        $group->save();
    
        if ($request->ajax()) {
            return response()->json($group);
        }
    
        return redirect()->route('group.index',$locale)->with('success', 'Group updated successfully');
    
    
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit($locale,string $id)
    {
        // Votre logique ici
        
        $group = GroupsCompany::findOrFail($id);
        return view('admin.companies.updategroup', compact('group'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update($locale,Request $request, string $id)
    {
    $request->validate([
        'name' => 'required|string|max:255',
    ]);

    $group = GroupsCompany::findOrFail($id);
    $group->name = $request->input('name');
    $group->save();

    if ($request->ajax()) {
        return response()->json($group);
    }

    return redirect()->route('group.index',$locale)->with('success', 'Group updated successfully');

    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy($locale,string $id)
    {
        $group = GroupsCompany::findOrFail($id);
        $group->delete();

        return redirect()->route('group.index', $locale)->with('success', 'Company deleted successfully.');
    }
}
