<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Menu;
use App\Models\Role;
use App\Models\Route;
use App\Models\Update;
use Illuminate\Http\Request;

class PermissionController extends Controller
{
    /**
     * permission (role, user, menu, route)
     */
    public function index()
    {
        $data = array();

        $roles = Role::where('status', '!=', -1)
                    ->orderBy('id', 'asc')
                    ->get();
        $data['roles'] = $roles;

        $menus = Menu::where('status', '!=', -1)
                    ->orderBy('position', 'asc')
                    ->orderBy('number', 'asc')
                    ->orderBy('id', 'asc')
                    ->get();
        $data['menus'] = $menus;

        $routes = Route::get();
        $data['routes'] = $routes;

        $updates = Update::where('status', '!=', -1)
                    ->get();
        $data['updates'] = $updates;

        return view('permission.index', $data);
    }
}
