<?php

namespace App\Http\Controllers\Clasify_Organise;
use App\Http\Controllers\Controller;
use App\Models\Department;
use Illuminate\Http\Request;

class DepartmentController extends Controller
{
     /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $departments = Department::all();
        return view('management.clasify_and_organise.department', compact('departments'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create($locale)
    {
        //
        return view('department.index');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store($locale,Request $request)
    {
        $request->validate([
            'name' => 'required|string|max:255',
            'company_id' => 'nullable|integer',

        ]);
    
        $department = new department();
        $department->name = $request->input('name');
        $department->company_id = auth()->user()->company_id; 
        $department->save();
    
        if ($request->ajax()) {
            return response()->json($department);
        }
    
        return redirect()->route('department.index',$locale)->with('success', 'department updated successfully');
    
    
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit($locale,string $id)
    {
        // Votre logique ici
        
        $department = Department::findOrFail($id);
        return view('management.clasify_and_organise.department', compact('department'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update($locale,Request $request, string $id)
    {
    $request->validate([
        'name' => 'required|string|max:255',
        'company_id' => 'nullable|integer',
    ]);

    $department = Department::findOrFail($id);
    $department->name = $request->input('name');
    $department->save();

    if ($request->ajax()) {
        return response()->json($department);
    }

    return redirect()->route('department.index',$locale)->with('success', 'department updated successfully');

    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy($locale,string $id)
    {
        $department = Department::findOrFail($id);
        $department->delete();

        return redirect()->route('department.index', $locale)->with('success', 'Company deleted successfully.');
    }
}

