<?php

namespace App\Http\Controllers\Clasify_Organise;
use App\Http\Controllers\Controller;
use App\Models\EmployeCategory;
use Illuminate\Http\Request;

class EmployeCategoryController extends Controller
{
     /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $employecategorys = EmployeCategory::all();
        return view('management.clasify_and_organise.employecategory', compact('employecategorys'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create($locale)
    {
        //
        return view('employecategory.index');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store($locale,Request $request)
    {
        $request->validate([
            'name' => 'required|string|max:255',
            'company_id' => 'nullable|integer',

        ]);
    
        $employecategory = new EmployeCategory();
        $employecategory->name = $request->input('name');
        $employecategory->company_id = auth()->user()->company_id;
        $employecategory->save();
    
        if ($request->ajax()) {
            return response()->json($employecategory);
        }
    
        return redirect()->route('employecategory.index',$locale)->with('success', 'employecategory updated successfully');
    
    
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit($locale,string $id)
    {
        // Votre logique ici
        
        $employecategory = EmployeCategory::findOrFail($id);
        return view('management.clasify_and_organise.employecategory', compact('employecategory'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update($locale,Request $request, string $id)
    {
    $request->validate([
        'name' => 'required|string|max:255',
        'company_id' => 'nullable|integer',
    ]);

    $employecategory = EmployeCategory::findOrFail($id);
    $employecategory->name = $request->input('name');
    $employecategory->save();

    if ($request->ajax()) {
        return response()->json($employecategory);
    }

    return redirect()->route('employecategory.index',$locale)->with('success', 'employecategory updated successfully');

    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy($locale,string $id)
    {
        $employecategory = EmployeCategory::findOrFail($id);
        $employecategory->delete();

        return redirect()->route('employecategory.index', $locale)->with('success', 'Company deleted successfully.');
    }
}

