<?php

namespace App\Http\Controllers\Clasify_Organise;
use App\Http\Controllers\Controller;
use App\Models\Employer;
use Illuminate\Http\Request;

class EmployerController extends Controller
{
     /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $employers = Employer::all();
        return view('management.clasify_and_organise.employer', compact('employers'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create($locale)
    {
        //
        return view('employer.index');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store($locale,Request $request)
    {
        $request->validate([
            'name' => 'required|string|max:255',
            'company_id' => 'nullable|integer',

        ]);
    
        $employer = new Employer();
        $employer->name = $request->input('name');
        $employer->company_id = auth()->user()->company_id;
        $employer->save();
    
        if ($request->ajax()) {
            return response()->json($employer);
        }
    
        return redirect()->route('employer.index',$locale)->with('success', 'employer updated successfully');
    
    
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit($locale,string $id)
    {
        // Votre logique ici
        
        $employer = Employer::findOrFail($id);
        return view('management.clasify_and_organise.employer', compact('employer'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update($locale,Request $request, string $id)
    {
    $request->validate([
        'name' => 'required|string|max:255',
        'company_id' => 'nullable|integer',
    ]);

    $employer = Employer::findOrFail($id);
    $employer->name = $request->input('name');
    $employer->save();

    if ($request->ajax()) {
        return response()->json($employer);
    }

    return redirect()->route('employer.index',$locale)->with('success', 'employer updated successfully');

    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy($locale,string $id)
    {
        $employer = Employer::findOrFail($id);
        $employer->delete();

        return redirect()->route('employer.index', $locale)->with('success', 'Company deleted successfully.');
    }
}

