<?php

namespace App\Http\Controllers\Clasify_Organise;
use App\Http\Controllers\Controller;
use App\Models\Location;
use Illuminate\Http\Request;

class LocationController extends Controller
{
     /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $locations = location::all();
        return view('management.clasify_and_organise.location', compact('locations'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create($locale)
    {
        //
        return view('location.index');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store($locale,Request $request)
    {
        $request->validate([
            'name' => 'required|string|max:255',
            'company_id' => 'nullable|integer',
            'code' => 'nullable|string|max:255',

        ]);
    
        $location = new location();
        $location->name = $request->input('name');
        $location->code = $request->input('code');
        $location->company_id = auth()->user()->company_id;
        $location->save();
    
        if ($request->ajax()) {
            return response()->json($location);
        }
    
        return redirect()->route('location.index',$locale)->with('success', 'location updated successfully');
    
    
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit($locale,string $id)
    {
        // Votre logique ici
        
        $location = location::findOrFail($id);
        return view('management.clasify_and_organise.location', compact('location'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update($locale,Request $request, string $id)
    {
    $request->validate([
        'name' => 'required|string|max:255',
        'company_id' => 'nullable|integer',
        'code' => 'nullable|string|max:255',
    ]);

    $location = location::findOrFail($id);
    $location->name = $request->input('name');
    $location->code = $request->input('code');
    $location->save();

    if ($request->ajax()) {
        return response()->json($location);
    }

    return redirect()->route('location.index',$locale)->with('success', 'location updated successfully');

    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy($locale,string $id)
    {
        $location = location::findOrFail($id);
        $location->delete();

        return redirect()->route('location.index', $locale)->with('success', 'Company deleted successfully.');
    }
}

