<?php

namespace App\Http\Controllers\Clasify_Organise;
use App\Http\Controllers\Controller;
use App\Models\PlaceOfBirth;
use Illuminate\Http\Request;

class PlaceOfBirthController extends Controller
{
     /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $placeofbirths = PlaceOfBirth::all();
        return view('management.clasify_and_organise.placeofbirth', compact('placeofbirths'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create($locale)
    {
        //
        return view('placeofbirth.index');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store($locale,Request $request)
    {
        $request->validate([
            'name' => 'required|string|max:255',
            'company_id' => 'nullable|integer',

        ]);
    
        $placeofbirth = new PlaceOfBirth();
        $placeofbirth->name = $request->input('name');
        $placeofbirth->company_id = auth()->user()->company_id;
        $placeofbirth->save();
    
        if ($request->ajax()) {
            return response()->json($placeofbirth);
        }
    
        return redirect()->route('placeofbirth.index',$locale)->with('success', 'placeofbirth updated successfully');
    
    
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit($locale,string $id)
    {
        // Votre logique ici
        
        $placeofbirth = PlaceOfBirth::findOrFail($id);
        return view('management.clasify_and_organise.placeofbirth', compact('placeofbirth'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update($locale,Request $request, string $id)
    {
    $request->validate([
        'name' => 'required|string|max:255',
        'company_id' => 'nullable|integer',
    ]);

    $placeofbirth = PlaceOfBirth::findOrFail($id);
    $placeofbirth->name = $request->input('name');
    $placeofbirth->save();

    if ($request->ajax()) {
        return response()->json($placeofbirth);
    }

    return redirect()->route('placeofbirth.index',$locale)->with('success', 'placeofbirth updated successfully');

    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy($locale,string $id)
    {
        $placeofbirth = PlaceOfBirth::findOrFail($id);
        $placeofbirth->delete();

        return redirect()->route('placeofbirth.index', $locale)->with('success', 'Company deleted successfully.');
    }
}

