<?php

namespace App\Http\Controllers\Clasify_Organise;

use App\Http\Controllers\Controller;
use App\Models\PortOfRegistry;
use Illuminate\Http\Request;

class PortOfRegistryController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $portofregistrys = PortOfRegistry::all();
        return view('management.clasify_and_organise.portofregistry', compact('portofregistrys'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create($locale)
    {
        //
        return view('portofregistry.index');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store($locale, Request $request)
    {
        $request->validate([
            'name' => 'required|string|max:255',
            'company_id' => 'nullable|integer',

        ]);

        $portofregistry = new PortOfRegistry();
        $portofregistry->name = $request->input('name');
        $portofregistry->company_id = auth()->user()->company_id;
        $portofregistry->save();

        if ($request->ajax()) {
            return response()->json($portofregistry);
        }

        return redirect()->route('portofregistry.index', $locale)->with('success', 'PortOfRegistry updated successfully');
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit($locale, string $id)
    {
        // Votre logique ici

        $portofregistry = PortOfRegistry::findOrFail($id);
        return view('management.clasify_and_organise.portofregistry', compact('portofregistry'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update($locale, Request $request, string $id)
    {
        $request->validate([
            'name' => 'required|string|max:255',
            'company_id' => 'nullable|integer',
        ]);

        $portofregistry = PortOfRegistry::findOrFail($id);
        $portofregistry->name = $request->input('name');
        $portofregistry->save();

        if ($request->ajax()) {
            return response()->json($portofregistry);
        }

        return redirect()->route('portofregistry.index', $locale)->with('success', 'PortOfRegistry updated successfully');
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy($locale, string $id)
    {
        $portofregistry = PortOfRegistry::findOrFail($id);
        $portofregistry->delete();

        return redirect()->route('portofregistry.index', $locale)->with('success', 'Company deleted successfully.');
    }
}
