<?php

namespace App\Http\Controllers\Clasify_Organise;
use App\Http\Controllers\Controller;
use App\Models\Section;
use Illuminate\Http\Request;

class SectionController extends Controller
{
     /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $sections = Section::all();
        return view('management.clasify_and_organise.section', compact('sections'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create($locale)
    {
        //
        return view('section.index');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store($locale,Request $request)
    {
        $request->validate([
            'name' => 'required|string|max:255',
            'company_id' => 'nullable|integer',

        ]);
    
        $section = new section();
        $section->name = $request->input('name');
        $section->company_id = auth()->user()->company_id;
        $section->save();
    
        if ($request->ajax()) {
            return response()->json($section);
        }
    
        return redirect()->route('section.index',$locale)->with('success', 'section updated successfully');
    
    
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit($locale,string $id)
    {
        // Votre logique ici
        
        $section = Section::findOrFail($id);
        return view('management.clasify_and_organise.section', compact('section'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update($locale,Request $request, string $id)
    {
    $request->validate([
        'name' => 'required|string|max:255',
        'company_id' => 'nullable|integer',
    ]);

    $section = Section::findOrFail($id);
    $section->name = $request->input('name');
    $section->save();

    if ($request->ajax()) {
        return response()->json($section);
    }

    return redirect()->route('section.index',$locale)->with('success', 'section updated successfully');

    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy($locale,string $id)
    {
        $section = Section::findOrFail($id);
        $section->delete();

        return redirect()->route('section.index', $locale)->with('success', 'Company deleted successfully.');
    }
}

