<?php

namespace App\Http\Controllers\Clasify_Organise;
use App\Http\Controllers\Controller;
use App\Models\Subdepartment;
use Illuminate\Http\Request;

class SubdepartmentController extends Controller
{
     /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $subdepartments = Subdepartment::all();
        return view('management.clasify_and_organise.subdepartment', compact('subdepartments'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create($locale)
    {
        //
        return view('subdepartment.index');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store($locale,Request $request)
    {
        $request->validate([
            'name' => 'required|string|max:255',
            'company_id' => 'nullable|integer',

        ]);
    
        $subdepartment = new Subdepartment();
        $subdepartment->name = $request->input('name');
        $subdepartment->company_id = auth()->user()->company_id;
        $subdepartment->save();
    
        if ($request->ajax()) {
            return response()->json($subdepartment);
        }
    
        return redirect()->route('subdepartment.index',$locale)->with('success', 'subdepartment updated successfully');
    
    
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit($locale,string $id)
    {
        // Votre logique ici
        
        $subdepartment = Subdepartment::findOrFail($id);
        return view('management.clasify_and_organise.subdepartment', compact('Subdepartment'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update($locale,Request $request, string $id)
    {
    $request->validate([
        'name' => 'required|string|max:255',
        'company_id' => 'nullable|integer',
    ]);

    $subdepartment = Subdepartment::findOrFail($id);
    $subdepartment->name = $request->input('name');
    $subdepartment->save();

    if ($request->ajax()) {
        return response()->json($subdepartment);
    }

    return redirect()->route('subdepartment.index',$locale)->with('success', 'subdepartment updated successfully');

    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy($locale,string $id)
    {
        $subdepartment = Subdepartment::findOrFail($id);
        $subdepartment->delete();

        return redirect()->route('subdepartment.index', $locale)->with('success', 'Company deleted successfully.');
    }
}

