<?php

namespace App\Http\Controllers\Clasify_Organise;

use App\Http\Controllers\Controller;
use App\Models\Team;
use Illuminate\Http\Request;

class TeamController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $teams = Team::all();
        return view('management.clasify_and_organise.team', compact('teams'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create($locale)
    {
        //
        return view('team.index');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store($locale, Request $request)
    {
        $request->validate([
            'name' => 'required|string|max:255',
            'company_id' => 'nullable|integer',

        ]);

        $team = new team();
        $team->name = $request->input('name');
        $team->company_id = auth()->user()->company_id;
        $team->save();

        if ($request->ajax()) {
            return response()->json($team);
        }

        return redirect()->route('team.index', $locale)->with('success', 'team updated successfully');
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit($locale, string $id)
    {
        // Votre logique ici

        $team = Team::findOrFail($id);
        return view('management.clasify_and_organise.team', compact('team'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update($locale, Request $request, string $id)
    {
        $request->validate([
            'name' => 'required|string|max:255',
            'company_id' => 'nullable|integer',
        ]);

        $team = Team::findOrFail($id);
        $team->name = $request->input('name');
        $team->save();

        if ($request->ajax()) {
            return response()->json($team);
        }

        return redirect()->route('team.index', $locale)->with('success', 'team updated successfully');
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy($locale, string $id)
    {
        $team = Team::findOrFail($id);
        $team->delete();

        return redirect()->route('team.index', $locale)->with('success', 'Company deleted successfully.');
    }
}
