<?php

namespace App\Http\Controllers\Clasify_Organise;
use App\Http\Controllers\Controller;
use App\Models\TrainingLocation;
use Illuminate\Http\Request;

class TraininglocationController extends Controller
{
     /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $training_locations = TrainingLocation::all();
        return view('management.clasify_and_organise.traininglocation', compact('training_locations'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create($locale)
    {
        //
        return view('training_location.index');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store($locale,Request $request)
    {
        $request->validate([
            'name' => 'required|string|max:255',
            'company_id' => 'nullable|integer',

        ]);
    
        $training_location = new TrainingLocation();
        $training_location->name = $request->input('name');
        $training_location->company_id = auth()->user()->company_id;
        $training_location->save();
    
        if ($request->ajax()) {
            return response()->json($training_location);
        }
    
        return redirect()->route('training_location.index',$locale)->with('success', 'training_location updated successfully');
    
    
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit($locale,string $id)
    {
        // Votre logique ici
        
        $training_location = TrainingLocation::findOrFail($id);
        return view('management.clasify_and_organise.traininglocation', compact('training_location'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update($locale,Request $request, string $id)
    {
    $request->validate([
        'name' => 'required|string|max:255',
        'company_id' => 'nullable|integer',
    ]);

    $training_location = TrainingLocation::findOrFail($id);
    $training_location->name = $request->input('name');
    $training_location->save();

    if ($request->ajax()) {
        return response()->json($training_location);
    }

    return redirect()->route('training_location.index',$locale)->with('success', 'training_location updated successfully');

    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy($locale,string $id)
    {
        $training_location = TrainingLocation::findOrFail($id);
        $training_location->delete();

        return redirect()->route('training_location.index', $locale)->with('success', 'Company deleted successfully.');
    }
}

