<?php

namespace App\Http\Controllers\Clasify_Organise;
use App\Http\Controllers\Controller;
use App\Models\Work;
use Illuminate\Http\Request;

class WorkController extends Controller
{
     /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $works = Work::all();
        return view('management.clasify_and_organise.work', compact('works'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create($locale)
    {
        //
        return view('work.index');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store($locale,Request $request)
    {
        $request->validate([
            'name' => 'required|string|max:255',
            'company_id' => 'nullable|integer',
            'is_auto_evaluation' => 'nullable|integer',

        ]);
    
        $work = new work();
        $work->name = $request->input('name');
        $work->company_id = auth()->user()->company_id;
        $work->save();
    
        if ($request->ajax()) {
            return response()->json($work);
        }
    
        return redirect()->route('work.index',$locale)->with('success', 'work updated successfully');
    
    
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit($locale,string $id)
    {
        // Votre logique ici
        
        $work = Work::findOrFail($id);
        return view('management.clasify_and_organise.work', compact('work'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update($locale,Request $request, string $id)
    {
    $request->validate([
            'name' => 'required|string|max:255',
            'company_id' => 'nullable|integer',
            'is_auto_evaluation' => 'nullable|integer',
    ]);

    $work = Work::findOrFail($id);
    $work->name = $request->input('name');
    $work->save();

    if ($request->ajax()) {
        return response()->json($work);
    }

    return redirect()->route('work.index',$locale)->with('success', 'work updated successfully');

    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy($locale,string $id)
    {
        $work = Work::findOrFail($id);
        $work->delete();

        return redirect()->route('work.index', $locale)->with('success', 'Company deleted successfully.');
    }
}

