<?php

namespace App\Http\Controllers\CompetencyCards;

use App\Http\Controllers\Controller;
use App\Models\Competency;
use Illuminate\Http\Request;

class CompetencyCardsController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $competencys = competency::all();
        return view('management.competency_cards.competency', compact('competencys'));
    }

    public function list()
    {
        //
        return view('management.competency_cards.competency_cards');
    }

   
    /**
     * Show the form for creating a new resource.
     */
    public function create($locale)
    {
        //
        return view('competency.index');
    }

    public function createusercompetency($locale)
    {
        //
        return view('management.competency_cards.competency_users');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store($locale,Request $request)
    {
        $request->validate([
            'name' => 'required|string|max:255',
            'prefix' => 'required|string|max:255',
            'company_id' => 'nullable|integer',

        ]);
    
        $competency = new competency();
        $competency->name = $request->input('name');
        $competency->prefix = $request->input('prefix');
        $competency->save();
    
        if ($request->ajax()) {
            return response()->json($competency);
        }
    
        return redirect()->route('competency.index',$locale)->with('success', 'competency updated successfully');
    
    
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit($locale,string $id)
    {
        // Votre logique ici
        
        $competency = competency::findOrFail($id);
        return view('management.competency_cards.competency', compact('competency'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update($locale,Request $request, string $id)
    {
        $request->validate([
            'name' => 'required|string|max:255',
            'prefix' => 'required|string|max:255',
            'company_id' => 'nullable|integer',

        ]);
    
        $competency = competency::findOrFail($id);
        $competency->name = $request->input('name');
        $competency->prefix = $request->input('prefix');
        $competency->save();

    if ($request->ajax()) {
        return response()->json($competency);
    }

    return redirect()->route('competency.index',$locale)->with('success', 'competency updated successfully');

    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy($locale,string $id)
    {
        $competency = competency::findOrFail($id);
        $competency->delete();

        return redirect()->route('competency.index', $locale)->with('success', 'competency deleted successfully.');
    }
}
