<?php

namespace App\Http\Controllers\LibraryVideo;

use App\Http\Controllers\Controller;
use App\Models\LibraryVideoHistory;
use App\Models\UserTraining;
use App\Models\Category;
use Illuminate\Http\Request;

class LibraryVideoHistoryController extends Controller
{
    /**
     * Affiche l'historique des vidéos avec pagination et filtres.
     */
    public function list(Request $request)
    {


        // Initialiser la requête avec les relations
        $query = LibraryVideoHistory::with(['video', 'user']);

        // Appliquer les filtres si des paramètres sont fournis
        if ($request->filled('video_name')) {
            $query->whereHas('video', function ($q) use ($request) {
                $q->where('name', 'like', '%' . $request->video_name . '%');
            });
        }

        if ($request->filled('matricule')) {
            $query->whereHas('user', function ($q) use ($request) {
                $q->where('matricule', 'like', '%' . $request->matricule . '%');
            });
        }

        if ($request->filled('user_name')) {
            $query->whereHas('user', function ($q) use ($request) {
                $q->where('name', 'like', '%' . $request->user_name . '%');
            });
        }

        if ($request->filled('date')) {
            $query->where('date', $request->date);
        }

        // Trier et paginer les résultats
        $history = LibraryVideoHistory::with(['video', 'user'])
            ->orderBy('date', 'desc')
            ->paginate(5);

        return view('libraryvideo.history', compact('history'));
    }
}
