<?php

namespace App\Http\Controllers;

use App\Models\Category;
use App\Models\UserTraining;
use Illuminate\Http\Request;
use App\Models\Training;

class OnlineProcedureReadingController extends Controller
{
    /**
     * Affiche la liste des ressources.
     */
    public function index()
    {
        return view('train.onlineprocedure');
    }

    /**
     * Affiche les détails d'une ressource spécifiée.
     */
    public function show(Request $request)
    {
        $data = array();
        $category_id = $request->input('category_id'); // Utilisez input() pour éviter les erreurs si la clé n'existe pas
        $category = Category::find($category_id);


            $data['category'] = $category;

            // Récupération des formations de l'utilisateur
            $user_trainings = UserTraining::where('user_id', $this->user->id)
                ->where('company_id', $this->company->id)
                ->where('category_id', $category_id)
                ->orderBy('id')
                ->get();

            foreach ($user_trainings as $user_training) {
                $image = $this->unserialize($user_training->training->image);

                // Vérifiez que $image contient bien le chemin du PDF
                if ($image) {
                    $user_training->training->image = $image;
                    \Log::info('Chemin du PDF : ', ['path' => $image]); // Ajout d'un log pour le chemin
                } else {
                    \Log::warning('Le chemin du PDF est vide ou invalide pour l\'ID de formation : ' . $user_training->training->id);
                }
            }

            $data["user_trainings"] = $user_trainings;

        return view('train.onlineprocedure', $data);
    }

    /**
     * Affiche le formulaire pour créer une nouvelle ressource.
     */
    public function create()
    {
        // Ajoutez votre logique ici
    }

    /**
     * Stocke une nouvelle ressource dans le stockage.
     */
    public function store(Request $request)
    {
        // Ajoutez votre logique ici
    }

    /**
     * Affiche le formulaire pour modifier la ressource spécifiée.
     */
    public function edit(string $id)
    {
        // Ajoutez votre logique ici
    }

    /**
     * Met à jour la ressource spécifiée dans le stockage.
     */
    public function update(Request $request, string $id)
    {
        // Ajoutez votre logique ici
    }

    /**
     * Supprime la ressource spécifiée du stockage.
     */
    public function destroy(string $id)
    {
        // Ajoutez votre logique ici
    }

    /**
     * Désérialise les données.
     */
    public function unserialize($data) // Changez private à public
    {
        if (empty($data)) {
            \Log::warning('Données à désérialiser sont vides.');
            return null; // Ou une valeur par défaut
        }

        $unserializedData = @unserialize($data); // Utilisez le "@" pour ignorer les erreurs de désérialisation

        if ($unserializedData === false && $data !== 'b:0;') {
            \Log::error('Erreur de désérialisation : ', ['data' => $data]);
            return null;
        }

        \Log::info('Données désérialisées : ', ['data' => $unserializedData]);

        return $unserializedData;
    }
}
