<?php

namespace App\Http\Controllers\Training;

use App\Http\Controllers\Controller;
use App\Models\Activity;
use App\Models\ActivityPresentiel;
use App\Models\Presentiel;
use Illuminate\Http\Request;

class ActivityPresentielController extends Controller
{
    /**
     * store
     */
    public function store(Request $request, $locale)
    {
        $id = $request->input('id');
        $presentiel_id = $request->input('presentiel_id');
        
        $trainer_id = $request->input('trainer_id');
        $date = $request->input('date');
        $type = $request->input('type');
        $duration = $request->input('duration');
        $status = $request->input('status');
        $notes = $request->input('notes');

        $duration = is_numeric($duration) ? $duration : $this->time_to_minute($duration);
        $data = array(
            'trainer_id' => $trainer_id,
            'duration' => $duration,
            'status' => $status,
            'notes' => $notes
        );
        if (!$id)
        {
            $data['presentiel_id'] = $presentiel_id;
            $data['date'] = $date;
            $data['type'] = $type;
        }
        $data = $this->get_not_null($data);
        
        if ($id)
        {
            $activity_presentiel = ActivityPresentiel::find($id);
            if ($activity_presentiel) 
            {
                $activity_presentiel->update($data);
            }
            else
            {
                $this->not_found();
            }
        }
        else
        {
            $activity_presentiel = ActivityPresentiel::create($data);
            $presentiel = Presentiel::find($presentiel_id);
            foreach ($presentiel->assigned_training as $assigned_training)
            {
                $data = array(
                    'assigned_training_id' => $assigned_training->id,
                    'trainer_id' => $trainer_id,
                    'date' => $date,
                    'type' => $type,
                    'duration' => $duration,
                    'status' => $status,
                    'notes' => $notes,
                    'activity_presentiel_id' => $activity_presentiel->id
                );
                $activity = Activity::create($data);
            }
        }
        
        return redirect()->route('presentiel.view', [$locale, $presentiel_id])->with('success', __('message.successfully_registered'));
    }
    
    /**
     * done
     */
    public function done(Request $request, $locale)
    {
        $id = $request->id;
        
        $activity_presentiel = ActivityPresentiel::find($id);
        if ($activity_presentiel) 
        {
            $presentiel_id = $activity_presentiel->presentiel_id;
            $data = array(
                'completed' => 1,
                'status' => 'Completed'
            );
            $data = $this->get_not_null($data);
            $activity_presentiel->update($data);
        }
        else
        {
            $this->not_found();
        }
        
        return redirect()->route('presentiel.view', [$locale, $presentiel_id])->with('success', __('message.successfully_registered'));
    }

    /**
     * destroy
     */
    public function destroy(Request $request, $locale)
    {
        $id = $request->id;
        $presentiel_id = $request->presentiel_id;
        $activity_presentiel = ActivityPresentiel::find($id);

        if ($activity_presentiel) 
        {
            foreach ($activity_presentiel->activities as $activity)
            {
                $assigned_training = $activity->assigned_training;
                $assigned_training->delete();
                $activity->delete();
            }
            $activity_presentiel->delete();

            return redirect()->route('presentiel.view', [$locale, $presentiel_id])->with('success', __('message.successfully_deleted'));
        } 
        else 
        {
            return redirect()->route('presentiel.view', [$locale, $presentiel_id])->with('error', __('message.error_deleting'));
        }
    }
}
