<?php

namespace App\Http\Controllers\Training;

use App\Http\Controllers\Controller;
use App\Models\TrainingLevel;
use Illuminate\Http\Request;

class TrainingLevelController extends Controller
{
    /**
     * index
     */
    public function index()
    {
        $data = array();
        
        $training_levels = TrainingLevel::where('company_id', $this->company->id)->get();
        $data['training_levels'] = $training_levels;

        return view('training.training-level', $data);
    }

    /**
     * store
     */
    public function store(Request $request, $locale)
    {
        $validated = $request->validate([
            'name' => 'required'
        ]);

        $id = $request->input('id');
        $training_category = TrainingLevel::find($id);

        if ($training_category) 
        {
            $this->check_company($training_category);
            $data = array(
                'name' => $request->name,
            );
            $training_category->update($data);
        }
        else
        {
            $data = array(
                'name' => $request->name,
                'company_id' => $this->company->id
            );
            $training_category = TrainingLevel::create($data);
        }
        
        return redirect()->route('training-level.list', [$locale])->with('success', __('message.successfully_registered'));
    }

    /**
     * destroy
     */
    public function destroy(Request $request, $locale)
    {
        $id = $request->id;
        $training_category = TrainingLevel::find($id);

        if ($training_category) 
        {
            $this->check_company($training_category);
            $training_category->delete();

            return redirect()->route('training-level.list', [$locale])->with('success', __('message.successfully_deleted'));
        } 
        else 
        {
            return redirect()->route('training-level.list', [$locale])->with('error', __('message.error_deleting'));
        }
    }
}
