<?php

namespace App\Http\Controllers\Training;

use App\Http\Controllers\Controller;
use App\Models\Category;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class UserAssignController extends Controller
{
    /**
     * users
     */
    public function users(Request $request)
    {
        $data = array();

        /*
        $users = DB::table('users')
                    ->leftJoin('users_roles', 'users_roles.user_id', 'users.id')
                    ->whereIn('users_roles.role_id', [4])
                    ->where('users.status', '=', 1)
                    ->where('users.company_id', $this->company->id)
                    ->select(['users.*'])
                    ->orderBy('users.fname', 'asc')
                    ->orderBy('users.lname', 'asc')
                    ->orderBy('users.id', 'asc')
                    ->get();
        */
        $users = User::where('company_id', $this->company->id)
                    ->get();
        $data['users']  = $users;
        
        return view('training.user-assign.users', $data);
    }

    /**
     * view
     */
    public function view(Request $request)
    {
        $data = array();

        $id = $request->id;
        $user = User::find($id);
        if ($user)
        {
            $this->check_company($user);
            $data["user"] = $user;

            $categories = Category::where('id', '<=', 9)
                            ->orderBy('id', 'ASC')
                            ->get();
            foreach ($categories as $category)
            {
                if ($category->id <= 6)
                {
                    $data['user_trainings_' . $category->id] = [];
                }
            }
            $data["categories"] = $categories;
            foreach ($user->user_trainings as $user_training)
            {
                $user_training->training->duration = $this->sec_to_time($user_training->training->duration_pr + $user_training->training->duration_pr);
                $data['user_trainings_' . $user_training->training->category_id][] = $user_training;
            }

            $data['user_forms_7'] = [];
            $data['user_forms_9'] = [];
            foreach ($user->user_forms as $user_form)
            {
                if ($user_form->form->category_id == 7)
                {
                    $data['user_forms_7'][] = $user_form;
                }
                if ($user_form->form->category_id == 9)
                {
                    $data['user_forms_9'][] = $user_form;
                }
            }
            $data['user_reports'] = $user->user_reports;

            $data['is_assign'] = true;
        }
        else
        {
            $this->not_found();
        }
        return view('training.user-assign.view', $data);
    }

    /**
     * groups
     */
    public function groups(Request $request)
    {
        $data = array();
        
        return view('training.user-assign.groups', $data);
    }
}
