<?php

namespace App\Http\Controllers\User;

use App\Http\Controllers\Controller;
use App\Mail\FriendlyReminderMail;
use App\Mail\UserCreated;
use App\Models\CompetencyUser;
use App\Models\Instructor;
use App\Models\Supervisor;
use App\Models\UserTraining;
use App\Models\TrainingService;
use App\Models\User;
use App\Models\Competency;
use App\Models\PlaceOfBirth;
use App\Models\Company;
use App\Models\Trainer;
use App\Models\Department;
use App\Models\Location;
use App\Models\Subdepartment;
use App\Models\Employer;
use App\Models\Section;
use App\Models\Team;
use App\Models\EmployeCategory;
use App\Models\Langs;
use App\Models\PortOfRegistry;
use App\Models\Role;
use App\Models\RolesRoutes;
use App\Models\Training;
use App\Models\Work;
use App\Models\Category;
use App\Models\Equipement;
use App\Models\Form;
use App\Models\Module;
use App\Models\Platform;
use App\Models\Report;
use App\Models\RList;
use App\Models\Signer;
use App\Models\TrainingLevel;
use App\Models\TrainingResult;
use App\Models\JobTrainingGroup;
use App\Models\UsersRoles;
use App\Models\ExternalTrainingFolder;
use Illuminate\Auth\Events\Registered;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Mail\Mailables\Address;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Session;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Mail;
use App\Models\Matricule;
use Endroid\QrCode\QrCode;
use Endroid\QrCode\Writer\PngWriter;

class UserController extends Controller
{
    protected $data;
    /**
     * Display the dashboard view.
     */
    public function list()
    {
        $users = User::all();
        return view('management.users.list', compact('users'));

    }

    /**
     * List all users.
     */
    public function index(Request $request, $locale, $is_temporary = 0)
    {
        $request->session()->put('management.users.list.is_temporary', $is_temporary);

        $users = User::all(); $job_training_groups = JobTrainingGroup::where('company_id', $this->company->id)->get();
        $data['job_training_groups'] = $job_training_groups;

        $categories = Category::where('id', '<=', 6)->get();
        $data['categories'] = $categories;

        return view('management.users.list', compact('users'));
    }

    /**
     * View user details.
     */
    public function view(Request $request, $locale, $id)
    {
        $competencyUsers = CompetencyUser::with(['competency', 'service', 'user'])
            ->where('company_id', $this->company->id)
            ->get();
        $competencies = Competency::all();
        $UserRole = UsersRoles::all();
        $services = TrainingService::all();
        $users = User::all();
        $user = User::findOrFail($id);
        $companies = Company::all();
        $placeofbirths = PlaceOfBirth::all();
        $subdepartments = Subdepartment::where('company_id', $this->company->id)->get();
        $departments = Department::where('company_id', $this->company->id)->get();
        $employers = Employer::where('company_id', $this->company->id)->get();
        $sections = Section::all();
        $portofregistrys = PortOfRegistry::all();
        $locations = Location::where('company_id', $this->company->id)->get();
        $teams = Team::where('company_id', $this->company->id)->get();
        $employeeCategories = EmployeCategory::all();
        $jobs = Work::all();
        $rols = Role::all();
        $langues = Langs::all();
        $documents = ExternalTrainingFolder::where('user_id', $id)->get();
        // $trainings = $training_name = Training::where('company_id', $this->company->id)->get();
        $is_temporary = $request->session()->get('management.users.list.is_temporary');
        $data = array();
        $job_training_groups = JobTrainingGroup::where('company_id', $this->company->id)->get();
        $data['job_training_groups'] = $job_training_groups;
        $trainers = Trainer::where('company_id', $this->company->id)->get();
        $trainer_ids = [];
        foreach ($trainers as $trainer) {
            $trainer_ids[] = $trainer->id;
        }
        $data['trainers'] = $trainers;

        $trainer_users = User::where('company_id', $this->company->id)->whereNotIn('id', $trainer_ids)->get();
        $data['trainer_users'] = $trainer_users;
        //TRAINING AFFICHAGE
        $categories = Category::where('id', '<=', 6)->get();
        foreach ($categories as $category) {
            $data['training_' . $category->id] = array();
        }

        /*
        $count_all_training = 0;
        $count_disable_training = 0;
        $count_paid_training = 0;
        $count_immutable_training = 0;
        $trainings = Training::where('company_id', $this->company->id)->get();
        foreach ($trainings as $i => $training) {
            $training->duration_th = $this->sec_to_time($training->duration_th);
            $training->duration_pr = $this->sec_to_time($training->duration_pr);
            $data['training_' . $training->category_id][$i] = $training;
            $count_all_training++;
            if ($training->disable) $count_disable_training++;
            if ($training->paid) $count_paid_training++;
            if ($training->is_immutable) $count_immutable_training++;
        }

        $data['count_all_training'] = $count_all_training;
        $data['count_disable_training'] = $count_disable_training;
        $data['count_paid_training'] = $count_paid_training;
        $data['count_immutable_training'] = $count_immutable_training;

        $data['forms_7'] = Form::where('company_id', $this->company->id)->where('category_id', 7)->get();

        $data['forms_9'] = Form::where('company_id', $this->company->id)->where('category_id', 9)->get();

        $data['reports'] = Report::where('company_id', $this->company->id)->get();
        */
        $categories = Category::where('id', '<=', 9)
                        ->orderBy('id', 'ASC')
                        ->get();
        $data["categories"] = $categories;
        foreach ($categories as $category)
        {
            $data['user_trainings_' . $category->id] = [];
        }
        foreach ($user->user_trainings as $user_training)
        {
            $user_training->training->duration = $this->sec_to_time($user_training->training->duration_pr + $user_training->training->duration_pr);
            $data['user_trainings_' . $user_training->training->category_id][] = $user_training;
        }
        $data['user_forms_7'] = [];
        $data['user_forms_9'] = [];
        foreach ($user->user_forms as $user_form)
        {
            if ($user_form->form->category_id == 7)
            {
                $data['user_forms_7'][] = $user_form;
            }
            if ($user_form->form->category_id == 9)
            {
                $data['user_forms_9'][] = $user_form;
            }
        }
        $data['user_reports'] = $user->user_reports;
        $data['is_assign'] = false;

        return view('management.users.view', $data, compact(
            'user',
            'langues',
            'rols',
            'employeeCategories',
            'teams',
            'locations',
            'subdepartments',
            'departments',
            'portofregistrys',
            'companies',
            'placeofbirths',
            'employers',
            'sections',
            'jobs',
            'is_temporary',
            'trainers',
            // 'trainings',
            // 'training_name',
            'competencies',
            'competencyUsers',
            'services',
            'users',
            'job_training_groups',
            'documents'
        ));
    }

    /**
     * Show the form for creating a new user.
     */
    public function create(Request $request)
    {
        $companies = Company::all();
        $placeofbirths = PlaceOfBirth::all();
        $UserRole = UsersRoles::all();
        $subdepartments = Subdepartment::all();
        $departments = Department::all();
        $employers = Employer::all();
        $sections = Section::all();
        $portofregistrys = PortOfRegistry::all();
        $locations = Location::all();
        $teams = Team::all();
        $employeeCategories = EmployeCategory::all();
        $jobs = Work::all();
        $rols = Role::all();
        $langues = Langs::all();
        $is_temporary = $request->session()->get('management.users.list.is_temporary');

        return view('management.users.create', compact(
            'langues',
            'rols',
            'employeeCategories',
            'teams',
            'locations',
            'subdepartments',
            'departments',
            'portofregistrys',
            'companies',
            'placeofbirths',
            'employers',
            'sections',
            'jobs',
            'is_temporary'
        ));
    }

    /**
     * Store a newly created user in the database.
     */
    public function store($locale, Request $request): RedirectResponse
    {
        $validatedData = $request->validate([
            'uid' => 'nullable|string|max:64',
            'fname' => 'nullable|string|max:60',
            'lname' => 'nullable|string|max:60',
            'username' => 'nullable|string|max:64',
            'password' => 'nullable|string|max:64',
            'name' => 'nullable|string|max:255',
            'person_id' => 'nullable|string|max:255',
            'remember_token' => 'nullable|string|max:100',
            'ref' => 'nullable|string|max:64',
            'lang' => 'nullable|string|max:2',
            'email' => 'nullable|string|max:64',
            'email2' => 'nullable|string|max:64',
            'company_id' => 'nullable|string|max:64',
            'department_id' => 'nullable|string|max:64',
            'datestart' => 'nullable|string|max:64',
            'datestop' => 'nullable|string|max:64',
            'work_id' => 'nullable|string|max:64',
            'nas' => 'nullable|string|max:64',
            'sex' => 'nullable|string|max:64',
            'minority' => 'nullable|string|max:64',
            'subdepartment_id' => 'nullable|string|max:64',
            'employer_id' => 'nullable|string|max:64',
            'status' => 'nullable|string|max:64',
            'location_id' => 'nullable|string|max:64',
            'job_status' => 'nullable|string|max:64',
            'section_id' => 'nullable|string|max:64',
            'dateofbirth' => 'nullable|string|max:64',
            'employe_category_id' => 'nullable|string|max:64',
            'place_of_birth_id' => 'nullable|string|max:64',
            'port_attach_id' => 'nullable|string|max:64',
            'adress' => 'nullable|string|max:64',
            'phone_number' => 'nullable|string|max:64',
            'emergency_contact' => 'nullable|string|max:64',
            'emergency_phone_number' => 'nullable|string|max:64',
            'iscontractor' => 'nullable|boolean',
            'cross_id' => 'nullable|integer',
            'is_deleted' => 'nullable|boolean',
            'failed_logins' => 'nullable|integer',
            'security_answer' => 'nullable|string|max:255',
            'is_lockout_resp' => 'nullable|string|max:255',
            'is_adminreq' => 'nullable|string|max:255',
            'is_procedure_resp' => 'nullable|string|max:255',
            'team_id' => 'nullable|string|max:255',
            'avatar' => 'nullable|image|mimes:jpg,jpeg,png,gif,svg|max:2048',
        ]);

        // need to check if email or email2 is not empty
        if (!$request->email && !$request->email2) {
            $validatedData['email'] = $request->email;
            $validatedData['email2'] = $request->email2;

            // create form error for each field
            $validator = $request->validate([
                'email' => 'required|email',
                'email2' => 'required|email',
            ]);

            return redirect()->back()->withErrors($validator);
        }

        if ($request->hasFile('avatar')) {
            $file_paths = $this->store_files($request->file('avatar'), 'images');
            reset($file_paths);
            $filename = key($file_paths);
            $filepath = current($file_paths);
            $validatedData['avatar'] = $filepath;
        }

        $validatedData['ref'] = hash('sha256', $validatedData['username'] . '-' . $validatedData['company_id']);

        // Créer l'utilisateur et obtenir son ID
        $user = User::create($validatedData);

        if($user){
            $matricule = Matricule::where('companyID', auth()->user()->company_id)->first();
            $matricule->counter = $matricule->counter + 1;
            $matricule->save();
        }

        // Insérer l'entrée dans la table user_role
        UsersRoles::create([
            'user_id' => $user->id,  // ID de l'utilisateur nouvellement créé
            'role_id' => $request->input('ref'),  // Récupérer l'ID du rôle du formulaire
        ]);

        // choose email and send email here with password
        $email = $user->email ? $user->email : $user->email2;
        Mail::to($email)->send(new UserCreated($user, $request->password, $email));

        return redirect()->route('users.list', $locale)->with('success', 'User created successfully.');
    }

    /**
     * Show the form for editing the specified user.
     */
    public function edit($id)
    {
        $user = User::findOrFail($id);

        return view('users.edit', compact('user'));
    }

    /**
     * Update the specified user in the database.
     */
    public function update(Request $request, $id)
    {
        $validatedData = $request->validate([
            'uid' => 'nullable|string|max:64',
            'fname' => 'nullable|string|max:60',
            'lname' => 'nullable|string|max:60',
            'username' => 'nullable|string|max:64',
            'password' => 'nullable|string|max:64',
            'name' => 'nullable|string|max:255',
            'person_id' => 'nullable|string|max:255',
            'remember_token' => 'nullable|string|max:100',
            'ref' => 'nullable|string|max:64',
            'lang' => 'nullable|string|max:2',
            'email' => 'nullable|string|max:64',
            'email2' => 'nullable|string|max:64',
            'company_id' => 'nullable|string|max:64',
            'department_id' => 'nullable|string|max:64',
            'datestart' => 'nullable|string|max:64',
            'datestop' => 'nullable|string|max:64',
            'work_id' => 'nullable|string|max:64',
            'nas' => 'nullable|string|max:64',
            'sex' => 'nullable|string|max:64',
            'minority' => 'nullable|string|max:64',
            'subdepartment_id' => 'nullable|string|max:64',
            'employer_id' => 'nullable|string|max:64',
            'status' => 'nullable|string|max:64',
            'location_id' => 'nullable|string|max:64',
            'job_status' => 'nullable|string|max:64',
            'section_id' => 'nullable|string|max:64',
            'dateofbirth' => 'nullable|string|max:64',
            'employe_category_id' => 'nullable|string|max:64',
            'place_of_birth_id' => 'nullable|string|max:64',
            'port_attach_id' => 'nullable|string|max:64',
            'adress' => 'nullable|string|max:64',
            'phone_number' => 'nullable|string|max:64',
            'emergency_contact' => 'nullable|string|max:64',
            'emergency_phone_number' => 'nullable|string|max:64',
            'iscontractor' => 'nullable|boolean',
            'cross_id' => 'nullable|integer',
            'is_deleted' => 'nullable|boolean',
            'failed_logins' => 'nullable|integer',
            'security_answer' => 'nullable|string|max:255',
            'is_lockout_resp' => 'nullable|string|max:255',
            'is_adminreq' => 'nullable|string|max:255',
            'is_procedure_resp' => 'nullable|string|max:255',
            'team_id' => 'nullable|string|max:255',
        ]);

        $user = User::findOrFail($id);
        $user->update($validatedData);

        return redirect()->route('users.index')
            ->with('success', 'User updated successfully.');
    }

    /**
     * Remove the specified user from the database.
     */
    public function destroy($id)
    {
        $user = User::findOrFail($id);
        $user->delete();

        return redirect()->route('management.users.index')
            ->with('success', 'User deleted successfully.');
    }
    public function __construct(Request $request)
    {
        parent::__construct($request);

        $data = array();

        $data['category'] = Category::find($request->category_id);
        $data['platforms'] = Platform::get();
        $data['training_result'] = TrainingResult::get();
        $data['training_levels'] = TrainingLevel::where('company_id', $this->company->id)->get();
        $data['departments'] = Department::where('company_id', $this->company->id)->get();
        $data['subdepartments'] = Subdepartment::where('company_id', $this->company->id)->get();
        $data['locations'] = Location::where('company_id', $this->company->id)->get();
        $data['equipements'] = Equipement::where('company_id', $this->company->id)->get();
        $data['forms'] = Form::where('company_id', $this->company->id)->get();
        $data['surveys'] = Training::where('company_id', $this->company->id)->where('category_id', 5)->get();
        $data['signers'] = Signer::where('company_id', $this->company->id)->get();
        $data['yes_or_no_lists'] = RList::where('type', 'yes_or_no')->get();
        $data['following_trainings'] = Training::select('id', 'name', 'prefix')->where('company_id', $this->company->id)->where('active', 1)->where('disable', 0)->get();
        $data['procedure'] = $request->procedure;

        $this->data = $data;
    }

    public function select($locale, $role, $userID, $userTrainingID)
    {
        // Determine roles based on the input role
        $roles = $role == "Instructor" ? ["3", "5", "1"] : ["2", "5", "1"];

        // Fetch all users with the specified roles
        $modelAll = User::join('users_roles', 'users.id', '=', 'users_roles.user_id')
            //->where('users.company_id', auth()->user()->company_id)
            ->whereIn('users_roles.role_id', $roles)
            ->select('users.id', 'users.fname', 'users.lname')
            ->get();



        $utr = $userTrainingID;
        $alreadyAssigned = [];

        // Fetch assigned supervisors and instructors
        $sups = Supervisor::where('user_training_id', $utr)->get();
        $insts = Instructor::where('user_training_id', $utr)->get();

        // Get user IDs from supervisors and instructors
        $assignedUserIds = array_merge(
            $sups->pluck('user_id')->toArray(),
            $insts->pluck('user_id')->toArray()
        );

        // Filter out users that are already assigned
        $modelAll = $modelAll->filter(function($user) use ($assignedUserIds) {
            return !in_array($user->id, $assignedUserIds);
        });

        // Filter users not already assigned
        $model = $modelAll->filter(function ($m) use ($alreadyAssigned) {
            return !in_array($m->user_id, $alreadyAssigned);
        });

        // Return the select view with available users
        return view('management.users.select', ['model' => $model, 'role' => $role, 'userID' => $userID, 'userTrainingID' => $userTrainingID]);
    }

    public function saveSelect(Request $request, $locale, $role, $userID, $userTrainingID)
    {
        if($request->isMethod('post')) {
            $sel = $request->selection;

            if ($sel !== null) {
                $trID = $userTrainingID;

                foreach ($sel as $s) {
                    // Determine the model based on the role
                    if ($role == 'Instructor') {
                        $mod = new Instructor();
                    } elseif ($role == 'Supervisor') {
                        $mod = new Supervisor();
                    } else {
                        return view('select', ['model' => $model]);
                    }

                    $mod->user_id = $s;
                    $mod->user_training_id = $trID;

                    // Fetch user details
                    $u = User::find($mod->user_id);
                    $mod->fname = $u->fname;
                    $mod->lname = $u->lname;

                    $mod->save();
                }

                // Redirect to the user training view
                return redirect()->route('user-training.trainee', [$locale, 'id' => $trID]);
            }
        }
        // Determine roles based on the input role
        $roles = $role == "Instructor" ? ["3", "5", "1"] : ["2", "5", "1"];

        // Fetch all users with the specified roles
        $modelAll = User::join('users_roles', 'users.id', '=', 'users_roles.user_id')
            //->where('users.company_id', auth()->user()->company_id)
            ->whereIn('users_roles.role_id', $roles)
            ->select('users.id', 'users.fname', 'users.lname')
            ->get();

        $utr = request()->get('id');
        $alreadyAssigned = [];

        // Fetch assigned supervisors and instructors
        $sups = Supervisor::where('user_training_id', $utr)->get();
        $insts = Instructor::where('user_training_id', $utr)->get();

        // Collect already assigned user IDs
        foreach ($sups as $sup) {
            $alreadyAssigned[] = $sup->user_id;
        }
        foreach ($insts as $inst) {
            $alreadyAssigned[] = $inst->user_id;
        }

        // Filter users not already assigned
        $model = $modelAll->filter(function ($m) use ($alreadyAssigned) {
            return !in_array($m->user_id, $alreadyAssigned);
        });


        return view('management.users.select', ['model' => $model, 'role' => $role, 'userID' => $userID, 'userTrainingID' => $userTrainingID]);

    }

    public function myTrainees($locale){

         //$connected user
         $connected_user = auth()->user();

         //check role
         $isSupervisor = false;
         $isInstructor = false;
         $isSuper_trainer = false;
         $isTrainee = false;
         $isContractor = false;
         $isTrainer = false;

         if($connected_user->role_user->role_id == 2){
             $isSupervisor = true;
         }
         if($connected_user->role_user->role_id == 3){
             $isInstructor = true;
         }
         if($connected_user->role_user->role_id == 1){
             $isSuper_trainer = true;
         }

         if($connected_user->role_user->role_id == 4){
             $isTrainee = true;
         }

         if($connected_user->role_user->role_id == 5){
             $isTrainer = true;
         }

         if($connected_user->role_user->role_id == 6){
             $isContractor = true;
         }

         if($isSupervisor){
            $trainees = Supervisor::join('user_training', 'supervisors.user_training_id', '=', 'user_training.id')
                ->join('users', 'user_training.user_id', '=', 'users.id')
                ->where('supervisors.user_id', auth()->user()->id)
                ->select('users.id', 'users.fname', 'users.lname')  // Specify exactly which columns you want
                ->groupBy('users.id', 'users.fname', 'users.lname') // Include all non-aggregated columns
                ->get();
        } else if($isInstructor){
            $trainees = Instructor::join('user_training', 'instructors.user_training_id', '=', 'user_training.id')
                ->join('users', 'user_training.user_id', '=', 'users.id')
                ->where('instructors.user_id', auth()->user()->id)
                ->select('users.id', 'users.fname', 'users.lname')  // Specify exactly which columns you want
                ->groupBy('users.id', 'users.fname', 'users.lname') // Include all non-aggregated columns
                ->get();
        } else {
            $trainees = User::select('id', 'fname', 'lname')
            ->where('company_id', auth()->user()->company_id)
            ->orderBy('lname')
            ->get();

        }


        return view('management.users.mytrainees', [
            'trainees' => $trainees,
            'isSupervisor' => $isSupervisor,
            'isInstructor' => $isInstructor
        ]);
    }

    public function traineeDetails($locale, $trainee_id){
        $trainee = User::findOrFail($trainee_id);

        // Get all categories for the trainee
        $categories = Category::select('id', 'cat_name', 'new_name')
            ->where('id', '<', 9)
            ->orderBy('id')
            ->get();

        $Othertrainings = UserTraining::join('training', 'user_training.training_id', '=', 'training.id')
            ->where('user_training.user_id', $trainee_id)
            ->where('user_training.category_id', '!=', 3)
            ->get();

        $supervisors = Supervisor::join('user_training', 'supervisors.user_training_id', '=', 'user_training.id')
            ->where('user_training.user_id', $trainee_id)
            ->where('supervisors.user_id', auth()->user()->id)
            ->get();

        $instructors = Instructor::join('user_training', 'instructors.user_training_id', '=', 'user_training.id')
            ->where('user_training.user_id', $trainee_id)
            ->where('instructors.user_id', auth()->user()->id)
            ->get();

        $progress_a = 0;
        $progress_i = 0;
        $progress_s = 0;

        $connected_user = auth()->user();
        $role_id = optional(optional($connected_user->role_user)->role)->id;

        $isTrainee = false;
        $isInstructor = false;
        $isSupervisor = false;
        $isTrainer = false;

        if($role_id == 4){
            $isTrainee = true;
        }
        if($role_id == 3){
            $isInstructor = true;
        }
        if($role_id == 2){
            $isSupervisor = true;
        }
        if($role_id == 5){
            $isTrainer = true;
        }


        if($isSupervisor){
            $trainings = $supervisors;
            // $progress_s = $this->calculateProgress($trainings->user_training_id);
        } else if($isInstructor){
            $trainings = $instructors;
            // $progress_i = $this->calculateProgress($trainings->user_training_id);
        } else {
            $trainings = null;
            // $progress_a = $this->calculateProgress($trainings->user_training_id);
        }

        return view('management.users.traineedetails', [
            'trainee_id' => $trainee_id,
            'categories' => $categories,
            'trainings' => $trainings,
            'progress_a' => $progress_a,
            'progress_i' => $progress_i,
            'progress_s' => $progress_s,
            'isTrainee' => $isTrainee,
            'isInstructor' => $isInstructor,
            'isSupervisor' => $isSupervisor,
            'supervisors' => $supervisors,
            'instructors' => $instructors,
            'Othertrainings' => $Othertrainings,

        ]);
    }

    public function deleteSupervisorInstructor(Request $request, $locale, $role, $user_id, $user_training_id)
    {
        if ($role === 'supervisor') {
            // Delete supervisor record
            Supervisor::where('user_id', $user_id)
                     ->where('user_training_id', $user_training_id)
                     ->delete();
        } else if ($role === 'instructor') {
            // Delete instructor record
            Instructor::where('user_id', $user_id)
                     ->where('user_training_id', $user_training_id)
                     ->delete();
        }

        return redirect()->back()->with('success', __('app.deleted_successfully'));
    }

    public function setPrime(Request $request, $locale, $role, $user_id, $user_training_id)
    {
        if ($role === 'supervisor') {
            // First set all supervisors for this training to not prime
            Supervisor::where('user_training_id', $user_training_id)
                     ->update(['prime' => false]);

            // Then set the selected supervisor as prime
            Supervisor::where('user_id', $user_id)
                     ->where('user_training_id', $user_training_id)
                     ->update(['prime' => true]);
        } else if ($role === 'instructor') {
            // First set all instructors for this training to not prime
            Instructor::where('user_training_id', $user_training_id)
                     ->update(['prime' => false]);

            // Then set the selected instructor as prime
            Instructor::where('user_id', $user_id)
                     ->where('user_training_id', $user_training_id)
                     ->update(['prime' => true]);
        }

        return redirect()->back()->with('success', __('app.updated_successfully'));
    }

    public function loginAs(Request $request, $locale, $user_id)
    {
        // Store original user id in session
        session(['original_user_id' => auth()->id()]);

        // Login as the requested user
        Auth::loginUsingId($user_id);

        return redirect()->route('admin.dashboard', $locale)->with('success', __('app.logged_in_as_user'));
    }

    public function generate_matricule_id($locale, $company_id = NULL)
    {
        $user = new User();
        $matricule = $user->generate_matricule_id($company_id);
        return response()->json(['matricule' => $matricule]);
    }

    /**
     * Export users to Excel file
     */
    public function export()
    {
        $spreadsheet = new \PhpOffice\PhpSpreadsheet\Spreadsheet();
        $sheet = $spreadsheet->getActiveSheet();

        // Set headers
        $sheet->setCellValue('A1', 'ID');
        $sheet->setCellValue('B1', 'Name');
        $sheet->setCellValue('C1', 'Email');
        $sheet->setCellValue('D1', 'Company');
        $sheet->setCellValue('E1', 'Department');
        $sheet->setCellValue('F1', 'Position');
        $sheet->setCellValue('G1', 'Start Date');
        $sheet->setCellValue('H1', 'Matricule');
        $sheet->setCellValue('I1', 'Status');
        $sheet->setCellValue('J1', 'Langage');
        $sheet->setCellValue('K1', 'Sous département');
        $sheet->setCellValue('L1', 'Location');
        $sheet->setCellValue('N1', 'Responsable cadenassage');


        // Get users data
        $users = User::with(['company', 'department', 'work'])->get();

        $row = 2;
        foreach($users as $user) {
            $sheet->setCellValue('A' . $row, $user->id);
            $sheet->setCellValue('B' . $row, $user->name);
            $sheet->setCellValue('C' . $row, $user->email);
            $sheet->setCellValue('D' . $row, $user->company ? $user->company->name : '');
            $sheet->setCellValue('E' . $row, $user->department ? $user->department->name : '');
            $sheet->setCellValue('F' . $row, $user->work ? $user->work->name : '');
            $sheet->setCellValue('G' . $row, $user->datestart);
            $sheet->setCellValue('H' . $row, $user->matricule);
            $sheet->setCellValue('I' . $row, $user->status);
            $sheet->setCellValue('J' . $row, $user->langage);
            $sheet->setCellValue('K' . $row, $user->sous_departement);
            $sheet->setCellValue('L' . $row, $user->location->name);
            $sheet->setCellValue('N' . $row, $user->responsable_cadenassage);
            $row++;
        }

        // Auto size columns
        foreach(range('A','G') as $col) {
            $sheet->getColumnDimension($col)->setAutoSize(true);
        }

        // Create Excel file
        $writer = new \PhpOffice\PhpSpreadsheet\Writer\Xlsx($spreadsheet);

        $filename = 'users_' . date('Y-m-d') . '.xlsx';

        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header('Content-Disposition: attachment;filename="' . $filename . '"');
        header('Cache-Control: max-age=0');

        $writer->save('php://output');
        exit;
    }

    public function sendNotification($locale, User $user)
    {
        return view('management.users.sendNotification', ['user' => $user]);
    }

    public function notify(Request $request, $locale, User $user)
    {
        $notification_type = $request->notification_type;
        // Send a friendly reminder to the user
        $email = $user->email ? $user->email : $user->email2;

        // if not email, thorw an error
        if (!$email) {
            return redirect()->route('users.index', [$locale, $request->session()->get('management.users.list.is_temporary')])->with('error', __('app.no_email_found'));
        }

        switch ($notification_type) {
            case User::FRIENDLY_REMINDER_NOTIFICATION:
                $this->sendFriendlyReminder($user, $email);
                break;
        }

        return redirect()->route('users.index', [$locale, $request->session()->get('management.users.list.is_temporary')])->with('success', __('app.notification_sent_successfully'));
    }

    private function sendFriendlyReminder(User $user, $email)
    {
        Mail::to($email)->send(new FriendlyReminderMail($user));
    }

    public function ExternalTrainingFolder(Request $request)
    {
        $validated = $request->validate([
            'user_id' => 'required|exists:users,id',
            'description' => 'nullable|string|max:64',
            'filetype' => 'required|mimes:pdf,docx,doc|max:50000',
        ]);
        // Sauvegarde du fichier
        $filename = $request->file('filetype')->getClientOriginalName();
        $path = $request->file('filetype')->storeAs('documents', $filename, 'public');

        $folders = new ExternalTrainingFolder();
        $folders->user_id = $validated['user_id'];
        $folders->description = $validated['description'];
        $folders->filename = $filename;
        $folders->filetype = $path;
        $folders->save();

        return redirect()->back()->with('success', 'Document sauvegardé avec succès.');

    }


    /**
     * View QR code for a user
     */
    public function viewQr($locale, $id)
    {
        $a = array('À', 'Á', 'Â', 'Ã', 'Ä', 'Å', 'Æ', 'Ç', 'È', 'É', 'Ê', 'Ë', 'Ì', 'Í', 'Î', 'Ï', 'Ð', 'Ñ', 'Ò', 'Ó', 'Ô', 'Õ', 'Ö', 'Ø', 'Ù', 'Ú', 'Û', 'Ü', 'Ý', 'ß', 'à', 'á', 'â', 'ã', 'ä', 'å', 'æ', 'ç', 'è', 'é', 'ê', 'ë', 'ì', 'í', 'î', 'ï', 'ñ', 'ò', 'ó', 'ô', 'õ', 'ö', 'ø', 'ù', 'ú', 'û', 'ü', 'ý', 'ÿ', 'Ā', 'ā', 'Ă', 'ă', 'Ą', 'ą', 'Ć', 'ć', 'Ĉ', 'ĉ', 'Ċ', 'ċ', 'Č', 'č', 'Ď', 'ď', 'Đ', 'đ', 'Ē', 'ē', 'Ĕ', 'ĕ', 'Ė', 'ė', 'Ę', 'ę', 'Ě', 'ě', 'Ĝ', 'ĝ', 'Ğ', 'ğ', 'Ġ', 'ġ', 'Ģ', 'ģ', 'Ĥ', 'ĥ', 'Ħ', 'ħ', 'Ĩ', 'ĩ', 'Ī', 'ī', 'Ĭ', 'ĭ', 'Į', 'į', 'İ', 'ı', 'Ĳ', 'ĳ', 'Ĵ', 'ĵ', 'Ķ', 'ķ', 'Ĺ', 'ĺ', 'Ļ', 'ļ', 'Ľ', 'ľ', 'Ŀ', 'ŀ', 'Ł', 'ł', 'Ń', 'ń', 'Ņ', 'ņ', 'Ň', 'ň', 'ŉ', 'Ō', 'ō', 'Ŏ', 'ŏ', 'Ő', 'ő', 'Œ', 'œ', 'Ŕ', 'ŕ', 'Ŗ', 'ŗ', 'Ř', 'ř', 'Ś', 'ś', 'Ŝ', 'ŝ', 'Ş', 'ş', 'Š', 'š', 'Ţ', 'ţ', 'Ť', 'ť', 'Ŧ', 'ŧ', 'Ũ', 'ũ', 'Ū', 'ū', 'Ŭ', 'ŭ', 'Ů', 'ů', 'Ű', 'ű', 'Ų', 'ų', 'Ŵ', 'ŵ', 'Ŷ', 'ŷ', 'Ÿ', 'Ź', 'ź', 'Ż', 'ż', 'Ž', 'ž', 'ſ', 'ƒ', 'Ơ', 'ơ', 'Ư', 'ư', 'Ǎ', 'ǎ', 'Ǐ', 'ǐ', 'Ǒ', 'ǒ', 'Ǔ', 'ǔ', 'Ǖ', 'ǖ', 'Ǘ', 'ǘ', 'Ǚ', 'ǚ', 'Ǜ', 'ǜ', 'Ǻ', 'ǻ', 'Ǽ', 'ǽ', 'Ǿ', 'ǿ');
        $b = array('A', 'A', 'A', 'A', 'A', 'A', 'AE', 'C', 'E', 'E', 'E', 'E', 'I', 'I', 'I', 'I', 'D', 'N', 'O', 'O', 'O', 'O', 'O', 'O', 'U', 'U', 'U', 'U', 'Y', 's', 'a', 'a', 'a', 'a', 'a', 'a', 'ae', 'c', 'e', 'e', 'e', 'e', 'i', 'i', 'i', 'i', 'n', 'o', 'o', 'o', 'o', 'o', 'o', 'u', 'u', 'u', 'u', 'y', 'y', 'A', 'a', 'A', 'a', 'A', 'a', 'C', 'c', 'C', 'c', 'C', 'c', 'C', 'c', 'D', 'd', 'D', 'd', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'G', 'g', 'G', 'g', 'G', 'g', 'G', 'g', 'H', 'h', 'H', 'h', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', 'IJ', 'ij', 'J', 'j', 'K', 'k', 'L', 'l', 'L', 'l', 'L', 'l', 'L', 'l', 'l', 'l', 'N', 'n', 'N', 'n', 'N', 'n', 'n', 'O', 'o', 'O', 'o', 'O', 'o', 'OE', 'oe', 'R', 'r', 'R', 'r', 'R', 'r', 'S', 's', 'S', 's', 'S', 's', 'S', 's', 'T', 't', 'T', 't', 'T', 't', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'W', 'w', 'Y', 'y', 'Y', 'Z', 'z', 'Z', 'z', 'Z', 'z', 's', 'f', 'O', 'o', 'U', 'u', 'A', 'a', 'I', 'i', 'O', 'o', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'A', 'a', 'AE', 'ae', 'O', 'o');

        $user = User::findOrFail($id);

        if ($user->nas && $user->nas != '') {
            $code = $user->id . '_' . str_replace($a, $b, $user->lname) . ', ' . str_replace($a, $b, $user->fname) . ' (' . str_pad($user->nas, 3, "0", STR_PAD_LEFT) . ')';
        } else {
            $code = $user->id . '_' . str_replace($a, $b, $user->lname) . ', ' . str_replace($a, $b, $user->fname);
        }

        $writer = new \Endroid\QrCode\Writer\PngWriter();

        // Create QR code
        $qrCode = new \Endroid\QrCode\QrCode($code);

        $result = $writer->write($qrCode);

        return view('management.users.viewqr', [
            'qrCode' => $result,
            'id' => $id,
            'code' => $code
        ]);
    }

}
