<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Symfony\Component\HttpFoundation\Response;

class AccessMiddleware
{
    /**
     * Handle an incoming request.
     *
     * @param  \Closure(\Illuminate\Http\Request): (\Symfony\Component\HttpFoundation\Response)  $next
     */
    public function handle(Request $request, Closure $next): Response
    {   
        if (Auth::check())
        {
            $route_name = $request->route()->getName();
            $user_id = Auth::user()->id;
            $role_id = optional(optional(Auth::user()->role_user)->role)->id;
            $routes = DB::table('routes')
                            ->leftJoin('roles_routes', 'roles_routes.route_id', 'routes.id')
                            ->leftJoin('users_roles', 'users_roles.role_id', 'roles_routes.role_id')
                            ->where('users_roles.user_id', '=', $user_id)
                            ->where('routes.name', '=', $route_name)
                            ->select('routes.id')
                            ->first();
            if (!$routes)
            {
                if (!in_array($role_id, array(1, 2, 3, 4, 5, 6, 7)))
                {
                    abort(403, __("message.unauthorized_access"));
                }
            }
        }
        return $next($request);
    }
}
