<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Auth\Middleware\Authenticate;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Symfony\Component\HttpFoundation\Response;

class AuthenticateMiddleware extends Authenticate
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @param  string[]  ...$guards
     * @return mixed
     *
     * @throws \Illuminate\Auth\AuthenticationException
     */
    public function handle($request, Closure $next, ...$guards)
    {
        if (!Auth::check())
        {
            $locale = $request->segment(1);
            if (!in_array($locale, config('languages')))
            {
                $locale = env('APP_LOCALE', 'en');
            }
            return redirect()->route('login', $locale);
        }
        $this->authenticate($request, $guards);

        return $next($request);
    }
}
