<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasOne;

class Activity extends Model
{
    use HasFactory;

    protected $table = 'activities';

    protected $fillable = [
        'assigned_training_id',
        'date',
        'type',
        'completed',
        'trainer_id',
        'duration',
        'status',
        'notes',
        'documents',
        'activity_presentiel_id'
    ];

    /**
     * Get the assigned_training
     * 
     * @return AssignedTraining Object
     */
    public function assigned_training(): HasOne
    {
        return $this->hasOne(AssignedTraining::class, 'id', 'assigned_training_id')->withDefault();
    }

    /**
     * Get the activity_presentiel
     * 
     * @return ActivityPresentiel Object
     */
    public function activity_presentiel(): HasOne
    {
        return $this->hasOne(ActivityPresentiel::class, 'id', 'activity_presentiel_id')->withDefault();
    }

    /**
     * Get the trainer
     * 
     * @return Trainer Object
     */
    public function trainer(): HasOne
    {
        return $this->hasOne(Trainer::class, 'id', 'trainer_id')->withDefault();
    }
}
