<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasOne;

class ActivityPresentiel extends Model
{
    use HasFactory;

    protected $table = 'activities_presentiel';

    protected $fillable = [
        'name',
        'presentiel_id',
        'date',
        'type',
        'completed',
        'trainer_id',
        'duration',
        'status',
        'notes',
        'documents'
    ];

    /**
     * Get the presentiel
     * 
     * @return Presentiel Object
     */
    public function presentiel(): HasOne
    {
        return $this->hasOne(Presentiel::class, 'id', 'presentiel_id')->withDefault();
    }

    /**
     * Get the trainer
     * 
     * @return Trainer Object
     */
    public function trainer(): HasOne
    {
        return $this->hasOne(Trainer::class, 'id', 'trainer_id')->withDefault();
    }

    /**
     * Get the activities
     * 
     * @return Activity Object
     */
    public function activities()
    {
        return $this->hasMany(Activity::class, 'activity_presentiel_id', 'id')->orderBy('id');
    }
}
