<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Relations\HasOne;
use Illuminate\Database\Eloquent\Model;

class Company extends Model
{
    use HasFactory;

    // Ajoutez cette ligne si la table n'est pas `companies`
    protected $table = 'companies';

    protected $fillable = [
        'name',
        'logo',
        'logo2',
        'license_type',
        'max_users',
        'interforce_api',
        'isovision_api',
        'interforce_org_no',
        'task_video_restrict_fstforward',
        'task_video_reminder',
        'api_url',
        'display',
        'stripe_customer_id',
        'demand_require_team',
        'demand_require_division',
        'group_company_id',
        'apsm_code',
        'secret'
    ];

     /**
     * Get the company
     * 
     * @return GroupsCompany Object
     */
    public function GroupsCompany(): HasOne
    {
        return $this->hasOne(GroupsCompany::class, 'id','group_company_id');
    }
    
}
