<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Relations\HasOne;
use Illuminate\Database\Eloquent\Model;


class CompetencyCard extends Model

{
    use HasFactory;

    protected $table = 'competency_cards';
    protected $fillable = [

        'competency_name',

        'training_service',

        'curriculum',

        'approved',

        'company_id',

        'approved_by',

        'created_by',

    ];


    public function user()
    {
         return $this->belongsTo(User::class);
    }
 
    /* @return Company Object
    */
   public function company(): HasOne
   {
       return $this->hasOne(Company::class, 'id', 'company_id')->withDefault();
   }
    /* @return Company Object
    */
   public function competency()
     {
         return $this->belongsTo(Competency::class);
     }
 
     public function service()
     {
         return $this->belongsTo(TrainingService::class);
     }

}
