<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Relations\HasOne;
use Illuminate\Database\Eloquent\Model;

class CompetencyUser extends Model
{
    use HasFactory;

    protected $table = 'user_competencies';
    protected $fillable = [
        'id',
        'user_id',
        'competency_id',
        'service_id',
        'date',
        'certification',
        'company_id',
        'validity',
         
        
        

    ];

    /* @return user Object
    */
   public function user()
   {
        return $this->belongsTo(User::class);
   }

   /* @return Company Object
   */
  public function company(): HasOne
  {
      return $this->hasOne(Company::class, 'id', 'company_id')->withDefault();
  }
   /* @return Company Object
   */
  public function competency()
    {
        return $this->belongsTo(Competency::class);
    }

    public function service()
    {
        return $this->belongsTo(TrainingService::class);
    }
}
