<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Department extends Model
{
    use HasFactory;

    protected $table = 'departments';

    protected $fillable = [
        'name',
        'company_id'
    ];

    /**
     * Get the trainings
     * 
     * @return Training Object
     */
    public function trainings()
    {
        return $this->hasMany(Training::class, 'department_id', 'id')->orderBy('name');
    }
}
