<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use App\Models\Trait\ModelForCompanyTrait;

class Energies extends Model
{
    use HasFactory, SoftDeletes, ModelForCompanyTrait;

    protected $fillable = [
        'label_fr',
        'label_en',
        'type',
    ];

    protected $casts = [
        'type' => 'string',
    ];

    const TYPE_ELECTRIQUE = 'ELECTRIQUE';
    const TYPE_MECANIQUE = 'MECANIQUE';

    public static $types = [
        self::TYPE_ELECTRIQUE,
        self::TYPE_MECANIQUE,
    ];

    public function company()
    {
        return $this->belongsTo(Company::class, 'company_id');
    }

    public function getLabelFullAttribute($value)
    {
        return "FR: {$this->label_fr}<br>EN: {$this->label_en}";
    }

    public function getLabelAttribute($value)
    {
        return "FR: {$this->label_fr} | EN: {$this->label_en}";
    }
}
