<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasOne;

class ExternalTrainingFolder extends Model
{
    use HasFactory;

    protected $table = 'external_training_folder';

    protected $fillable = [
        'description',
        'filename',
        'filetype',
        'user_id'
    ];

    /**
     * Get the user
     * 
     * @return User Object
     */
    public function user(): HasOne
    {
        return $this->hasOne(User::class, 'id', 'user_id')->withDefault();
    }
}
