<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Group extends Model
{
    use HasFactory;

    protected $table = 'groups';

    protected $fillable = [
        'name',
        'description',
        'company_id'
    ];

    /**
     * Get the users
     * 
     * @return User Object
     */
    public function users()
    {
        return $this->belongsToMany(User::class, 'user_groups', 'group_id', 'user_id')->orderBy('id');
    }
}
