<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use App\Models\Trait\ModelForCompanyTrait;

class Instructions extends Model
{
    use HasFactory, SoftDeletes, ModelForCompanyTrait;

    protected $fillable = [
        'label_fr',
        'label_en',
        'company_id',
    ];

    public function company()
    {
        return $this->belongsTo(Company::class, 'company_id');
    }

    public function getLabelFullAttribute()
    {
        return "FR: {$this->label_fr}<br>EN: {$this->label_en}";
    }

    public function getLabelAttribute($value)
    {
        return "FR: {$this->label_fr} | EN: {$this->label_en}";
    }
}
