<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class JobTrainingGroup extends Model
{
    use HasFactory;

    protected $table = 'job_training_group';

    protected $fillable = [
        'prefix',
        'name',
        'description',
        'company_id'
    ];

    /**
     * Get the trainings
     * 
     * @return Training Object
     */
    public function trainings()
    {
        return $this->belongsToMany(Training::class, 'job_training_selection', 'job_training_group_id', 'training_id');
    }
}
