<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasOne;

class LibraryVideo extends Model
{
    use HasFactory;

    protected $table = 'library_video';

    protected $fillable = [
        'name',
        'company_id',
        'department_id',
        'work_id',
        'date_creation',
        'filename',
        'image',
        'filetype',
        'url',
        'display_order'
    ];

    /**
     * Get the company
     * 
     * @return Company Object
     */
    public function company(): HasOne
    {
        return $this->hasOne(Company::class, 'id', 'company_id')->withDefault();
    }

    /**
     * Get the department
     * 
     * @return Department Object
     */
    public function department(): HasOne
    {
        return $this->hasOne(Department::class, 'id', 'department_id')->withDefault();
    }

    /**
     * Get the work
     * 
     * @return Work Object
     */
    public function work(): HasOne
    {
        return $this->hasOne(Work::class, 'id', 'work_id')->withDefault();
    }
}
