<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasOne;

class LibraryVideoHistory extends Model
{
    use HasFactory;

    protected $table = 'library_video_history';

    protected $fillable = [
        'library_video_id',
        'user_id',
        'start_time',
        'stop_time',
        'date',
        'duration'
    ];

    /**
     * Get the library_video
     * 
     * @return LibraryVideo Object
     */
    public function video(): HasOne
    {
        return $this->hasOne(LibraryVideo::class, 'id', 'library_video_id')->withDefault();
    }

    /**
     * Get the user
     * 
     * @return User Object
     */
    public function user(): HasOne
    {
        return $this->hasOne(User::class, 'id', 'user_id')->withDefault();
    }
}
