<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use App\Models\Trait\ModelForCompanyTrait;

class Mechanisms extends Model
{
    use HasFactory, ModelForCompanyTrait;

    const STORAGE = "lockouts/mechanisms/icons";
    const PUBLIC_STORAGE = "assets/lockouts/mechanisms/icons/";

    const DEFAULT_ICON = "no-image.png";

    protected $table = 'mechanisms';
    public $timestamps = false;

    protected $fillable = [
        'type',
        'icon',
        'company_id',
    ];

    public function company(): \Illuminate\Database\Eloquent\Relations\BelongsTo
    {
        return $this->belongsTo(Company::class, 'company_id');
    }

    public function mechanisms(): \Illuminate\Database\Eloquent\Relations\HasMany
    {
        return $this->hasMany(__CLASS__);
    }

    public function getIconAttribute($value)
    {
        if(file_exists(public_path(self::PUBLIC_STORAGE . $value))) {
            return asset(self::PUBLIC_STORAGE  . $value);
        }

        return asset(self::PUBLIC_STORAGE . self::DEFAULT_ICON);
    }

    public function getTitleAttribute($value)
    {
        return file_exists(public_path(self::PUBLIC_STORAGE . $value)) ? $this->type : trans("app.noimage");
    }
}
