<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Module extends Model
{
    use HasFactory;

    protected $talbe = 'modules';

    protected $fillable = [
        'name',
        'type',
        'category_id',
        'company_id',
        'scorm_quiz'
    ];

    /**
     * Get the trainings
     * 
     * @return Training Object
     */
    public function trainings()
    {
        return $this->belongsToMany(Training::class, 'training_modules', 'module_id', 'training_id');
    }

    /**
     * Get the tasks
     * 
     * @return Task Object
     */
    public function tasks()
    {
        return $this->hasMany(Task::class, 'module_id', 'id')->orderBy('order');
    }
}
