<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasOne;

class TrackRecordAnswer extends Model
{
    use HasFactory;

    protected $table = 'track_record_answer';

    protected $fillable = [
        'track_record_id',
        'answer',
        'correct',
        'feedback',
        'filename',
        'filepath'
    ];

    /**
     * Get the track_record
     * 
     * @return TrackRecord Object
     */
    public function track_record(): HasOne
    {
        return $this->hasOne(TrackRecord::class, 'id', 'track_record_id')->withDefault();
    }
}
