<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasOne;

class TrainingCost extends Model
{
    use HasFactory;

    protected $table = 'training_costs';

    protected $fillable = [
        'presentiel_id',
        'cost',
        'type',
        'date',
        'notes'
    ];

    /**
     * Get the presentiel
     * 
     * @return Presentiel Object
     */
    public function presentiel(): HasOne
    {
        return $this->hasOne(Presentiel::class, 'id', 'presentiel_id')->withDefault();
    }

    /**
     * Get the cost_type
     * 
     * @return TrainingCostType Object
     */
    public function cost_type(): HasOne
    {
        return $this->hasOne(TrainingCostType::class, 'id', 'type')->withDefault();
    }
}
