<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasOne;

class TrainingDemandLevel extends Model
{
    use HasFactory;

    protected $table = 'training_demand_levels';

    protected $fillable = [
        'user_id',
        'level',
        'company_id',
        'linked_above',
        'req_step1_notification',
        'req_step2_notification',
        'req_step3_notification',
        'req_step4_notification',
        'trdem_step1_notification',
        'trdem_step2_notification',
        'trdem_step3_notification'
    ];

    /**
     * Get the user
     * 
     * @return User Object
     */
    public function user(): HasOne
    {
        return $this->hasOne(User::class, 'id', 'user_id')->withDefault();
    }

    /**
     * Get the company
     * 
     * @return Company Object
     */
    public function company(): HasOne
    {
        return $this->hasOne(Company::class, 'id', 'company_id')->withDefault();
    }
}
