<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasOne;

class TrainingDemandUser extends Model
{
    use HasFactory;

    protected $table = 'training_demand_users';

    protected $fillable = [
        'training_demand_id',
        'user_id'
    ];

    /**
     * Get the training_demand
     * 
     * @return TrainingDemand Object
     */
    public function training_demand(): HasOne
    {
        return $this->hasOne(TrainingDemand::class, 'id', 'training_demand_id')->withDefault();
    }

    /**
     * Get the user
     * 
     * @return User Object
     */
    public function user(): HasOne
    {
        return $this->hasOne(User::class, 'id', 'user_id')->withDefault();
    }
}
