<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class TrainingGroup extends Model
{
    use HasFactory;

    protected $table = 'training_group';

    protected $fillable = [
        'name',
        'description',
        'type',
        'prefix',
        'company_id',
        'interforce_profile_id',
        'under_revision'
    ];

    /**
     * Get the trainings
     * 
     * @return Training Object
     */
    public function trainings()
    {
        return $this->belongsToMany(Training::class, 'training_selection', 'training_group_id', 'training_id')->orderBy('id');
    }

    /**
     * Get the users
     * 
     * @return User Object
     */
    public function users()
    {
        return $this->belongsToMany(User::class, 'user_training_group', 'training_group_id', 'user_id')->orderBy('id');
    }
}
