<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasOne;

class TrainingReportQueue extends Model
{
    use HasFactory;

    protected $table = 'training_report_queues';

    protected $fillable = [
        'training_report_id',
        'recipient_id',
        'time_to_send'
    ];

    /**
     * Get the training_report
     * 
     * @return TrainingReport Object
     */
    public function training_report(): HasOne
    {
        return $this->hasOne(TrainingReport::class, 'id', 'training_report_id')->withDefault();
    }

    /**
     * Get the recipient
     * 
     * @return User Object
     */
    public function recipient(): HasOne
    {
        return $this->hasOne(User::class, 'id', 'recipient_id')->withDefault();
    }
}
