<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasOne;

class TrainingSelection extends Model
{
    use HasFactory;

    protected $table = 'training_selection';

    protected $fillable = [
        'training_group_id',
        'training_id',
        'category_id'
    ];

    /**
     * Get the training
     * 
     * @return Training Object
     */
    public function training(): HasOne
    {
        return $this->hasOne(Training::class, 'id', 'training_id')->withDefault();
    }
}
