<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasOne;

class TrainingSubReport extends Model
{
    use HasFactory;

    protected $table = 'training_subreports';

    protected $fillable = [
        'company_id',
        'name',
        'filters',
        'training_report_id',
        'description',
        'report_order',
        'images',
        'start_date',
        'end_date',
        'filter_type'
    ];

    /**
     * Get the company
     * 
     * @return Company Object
     */
    public function company(): HasOne
    {
        return $this->hasOne(Company::class, 'id', 'company_id')->withDefault();
    }

    /**
     * Get the training_report
     * 
     * @return TrainingReport Object
     */
    public function training_report(): HasOne
    {
        return $this->hasOne(TrainingReport::class, 'id', 'training_report_id')->withDefault();
    }
}
