<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasOne;

class UserReport extends Model
{
    use HasFactory;

    protected $table = 'user_reports';

    protected $fillable = [
        'user_id',
        'report_id',
        'completed',
        'completed_date',
        'active',
        'notification',
        'modified',
        'localisation',
        'responsible',
        'date',
        'hour'
    ];

    /**
     * Get the user
     * 
     * @return User Object
     */
    public function user(): HasOne
    {
        return $this->hasOne(User::class, 'id', 'user_id')->withDefault();
    }
    
    /**
     * Get the report
     * 
     * @return Report Object
     */
    public function report(): HasOne
    {
        return $this->hasOne(Report::class, 'id', 'report_id')->withDefault();
    }
}
