<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasOne;

class UserTrainingGroup extends Model
{
    use HasFactory;

    protected $table = 'user_training_group';

    protected $fillable = [
        'user_id',
        'training_group_id',
        'date',
        'completed'
    ];

    /**
     * Get the user
     * 
     * @return User Object
     */
    public function user(): HasOne
    {
        return $this->hasOne(User::class, 'id', 'user_id')->withDefault();
    }

    /**
     * Get the training_group
     * 
     * @return TrainingGroup Object
     */
    public function training_group(): HasOne
    {
        return $this->hasOne(TrainingGroup::class, 'id', 'training_group_id')->withDefault();
    }
}
