<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasOne;

class UserTrainingJob extends Model
{
    use HasFactory;

    protected $table = 'user_training_job';

    protected $fillable = [
        'user_id',
        'job_training_group_id',
        'date',
        'completed',
        'company_id'
    ];

    /**
     * Get the user
     * 
     * @return User Object
     */
    public function user(): HasOne
    {
        return $this->hasOne(User::class, 'id', 'user_id')->withDefault();
    }

    /**
     * Get the job_training_group
     * 
     * @return JobTrainingGroup Object
     */
    public function job_training_group(): HasOne
    {
        return $this->hasOne(JobTrainingGroup::class, 'id', 'job_training_group_id')->withDefault();
    }

    /**
     * Get the company
     * 
     * @return Company Object
     */
    public function company(): HasOne
    {
        return $this->hasOne(Company::class, 'id', 'company_id')->withDefault();
    }
}
