<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasOne;

class UserTrainingModule extends Model
{
    use HasFactory;

    protected $table = 'user_training_modules';

    protected $fillable = [
        'user_training_id',
        'module_id',
        'type',
        'completion_date',
        'score',
        'training'
    ];

    /**
     * Get the user_training
     * 
     * @return UserTraining Object
     */
    public function user_training(): HasOne
    {
        return $this->hasOne(UserTraining::class, 'id', 'user_training_id')->withDefault();
    }

    /**
     * Get the module
     * 
     * @return Module Object
     */
    public function module(): HasOne
    {
        return $this->hasOne(Module::class, 'id', 'module_id')->withDefault();
    }
}
