<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasOne;

class UsersRoles extends Model
{
    use HasFactory;

    protected $table = 'users_roles';
    protected $fillable = [
        'user_id',
        'role_id',
    ];

    /**
     * Get the role
     * 
     * @return Role Object
     */
    public function role(): HasOne
    {
        return $this->hasOne(Role::class, 'id', 'role_id')->withDefault();
    }
}
